﻿using Windows.UI.Xaml;
using Windows.UI.Xaml.Media;

namespace Animations
{
    public static class ChildrenOfTypeExtensions
    {
        public static T FindChildByType<T>(DependencyObject dependencyObject)
            where T : class
        {
            for (int i = 0; i < VisualTreeHelper.GetChildrenCount(dependencyObject); i++)
            {
                DependencyObject child = VisualTreeHelper.GetChild(dependencyObject, i);
                T childAsT = child as T;
                if (childAsT != null)
                {
                    return childAsT;
                }

                T subChild = FindChildByType<T>(child);
                if (subChild != null)
                {
                    return subChild;
                }
            }

            return null;
        }
    }
}
